=== debian/changelog ===
qmplay2 (1:19.08.27-1~mx17+2) mx; urgency=medium

  * Rebuild against test repo libs to preserve va-api acceleration.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 01 Sep 2019 16:46:07 -0700

qmplay2 (1:19.08.27-1~mx17+1) mx; urgency=medium

  * New upstream release:
    - a lot of VA-API improvements including zero-copy on OpenGL (some old
      drivers might cease to work - I can't test them).
    - fix loading of QMPlay2 modules (on some OS'es it leads to crash).
    - improve full screen switching (fixes regression since 18.12.26).
    - add "CustomUserAgent" into a "General" section in QMPlay2.ini.
    - fix black video when decoding videos with color palette.
    - add option to disable subtitles at program startup.
    - remove QMake build system, added Android to CMake.
    - display FFT spectrum in logarithmic scale.
    - improve displaying of graphical subtitles.
    - rewrite MediaBrowser, now use JavaScript.
    - a lot of YouTube and youtube-dl changes.
    - show native window file path separator.
    - add "opennew" command line argument.
    - display lyrics from file metadata.
    - fix language codes for MKV files.
    - add initial colorspace support.
    - add stereo channels swapping.
    - add "always on top" option.
    - bugfixes and improvements.
    - LastFM scrobble fixes.
    - require FFmpeg 3.3.

  * Add qtdeclarative5-dev and qttools5-dev as build-depends.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 01 Sep 2019 16:11:20 -0700
