=== debian/control ===
Source: qmplay2
Section: video
Priority: extra
Maintainer: Steven Pusser <stevep@mxlinux.org>
Bugs: mailto: maintainer@mepiscommunity.org
XSBC-Original-Maintainer: Rog131 <samrog131@hotmail.com>
Build-Depends: debhelper (>= 10),
 cmake (>= 3.1),
 pkg-config,
 qtbase5-dev (>= 5.6.3),
 qtdeclarative5-dev (>= 5.6.3),
 qttools5-dev (>= 5.6.3),
 qttools5-dev-tools (>= 5.6.3),
 libqt5x11extras5-dev (>= 5.6.3),
 libavcodec-dev (>= 7:3.3) | libavcodec-ffmpeg-dev (>= 7:3.3),
 libavdevice-dev (>= 7:3.3) | libavdevice-ffmpeg-dev (>= 7:3.3),
 libsidplayfp-dev (>= 1.6),
 libxv-dev, 
 libass-dev,
 libva-dev,
 libasound2-dev,
 libgme-dev,
 libjack-dev,
 libpulse-dev,
 libcdio-dev,
 libvdpau-dev,
 libcddb2-dev,
 libtag1-dev (>= 1.7)
Standards-Version: 3.9.6
Homepage: http://zaps166.sourceforge.net/?app=QMPlay2

Package: qmplay2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Qt based media player/streamer/downloader
 QMPlay2 is a video and audio playerand is able to play all formats supported by
 FFmpeg and libmodplug (including J2B and SFX). It also supports Audio CD,
 raw files and Rayman 2 music. It can browse and download YouTube and
 Prostopleer content.
 .
 It also supports online radio streams.  Youtube playback requires a recent
 youtube-dl, but the program will download it automatically if it can't find it
 on your system.
