## qmplay2 19.09.03

=== CMakeLists.txt ===
--- 
+++ 
@@ -185,6 +185,11 @@
 add_feature_info(Notifications USE_NOTIFY "Build additional notifications module")
 
 set(LANGUAGES "All" CACHE STRING "A space-seperated list of translations to compile into QMPlay2 or \"All\"")
+
+if(USE_FFMPEG_VAAPI OR USE_FFMPEG_VDPAU)
+    option(FIND_HWACCEL_DRIVERS_PATH "Find drivers path for hwaccel, useful for universal package" OFF)
+    add_feature_info(FindHwaccelDrivers FIND_HWACCEL_DRIVERS_PATH "Find drivers path for hwaccel")
+endif()
 
 if(NOT WIN32)
     # get QMPlay2 version by running the version script
@@ -314,9 +319,3 @@
     add_subdirectory(lang)
 endif()
 
-if(WIN32)
-    install(FILES AUTHORS ChangeLog LICENSE TODO README.md DESTINATION ${CMAKE_INSTALL_PREFIX})
-else()
-    install(FILES AUTHORS ChangeLog LICENSE TODO README.md DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/qmplay2")
-endif()
-
