=== src/modules/FFmpeg/CMakeLists.txt ===
--- 
+++ 
@@ -86,6 +86,10 @@
         list(APPEND FFmpeg_LIBS ${LIBVDPAU_LIBRARIES})
     endif()
 
+    if (FIND_HWACCEL_DRIVERS_PATH AND (USE_FFMPEG_VAAPI OR USE_FFMPEG_VDPAU))
+        add_definitions(-DFIND_HWACCEL_DRIVERS_PATH)
+    endif()
+
     if(USE_FFMPEG_DXVA2) # DXVA2
         add_definitions(-DQMPlay2_DXVA2)
         list(APPEND FFmpeg_HDR FFDecDXVA2.hpp)
