=== debian/changelog ===
qmplay2 (1:19.11.06-1~mx19+2) mx; urgency=medium

  * Rebuild against newer libs in test repo to keep from breaking va-api.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 13 Nov 2019 16:28:45 -0800

qmplay2 (1:19.11.06-1~mx19+1) mx; urgency=medium

  * New upstream release; build for MX Linux.
    - remove dedicated VDPAU video output and add VDPAU interoperation with
      OpenGL.
    - fix colorspace issues when using CPU deinterlacing filters.
    - improve bypassing compositor on Windows platform and OpenGL.
    - remove dedicated VA-API video output (use OpenGL instead).
    - add bypass compositor option on X11 platform and OpenGL.
    - fix playback error with VA-API deinterlacing filters.
    - fix EGL detection on X11/Intel (for VA-API).
    - allow enlargement of small cover images.
    - update Ukrainian translation file.
    - add VP9 codec support for VDPAU.
    - playlist quick sync fixes.
    - fix RTSP playback.
    - other minor fixes.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 08 Nov 2019 17:40:23 -0800
